import * as  React from 'react';
import PropTypes from 'prop-types';
import axios from 'axios';
import { isNullOrUndefined } from 'util';

const propTypes = {
    url: PropTypes.string,
    listArray: PropTypes.arrayOf(PropTypes.string),
    handleChange: PropTypes.func
}

const defaultProps = {
    url: '',
    listArray: []
}

class ReactDropDown extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            arrayList: []
        };
    }
    componentDidMount() {
        if (!isNullOrUndefined(this.props.url)) {
            axios.get(this.props.url).then(
                result => {
                    this.setState({ listArray: result.data });
                }
            );
        }
    }

    render() {
        if (!isNullOrUndefined(this.props.arrayList)) {
            return (
                <div>
                    <select onChange={(e) => this.props.handleChange(e.currentTarget.value)}>
                        {this.props.arrayList.map((list, i) =>
                            <option key={i} value={list}>{list}</option>
                        )}
                    </select>
                </div>
            )
        } else {
            return (
                <div>
                    <select onChange={(e) => this.props.handleChange(e.currentTarget.value)}>
                        {this.state.arrayList.map((list, i) =>
                            <option key={i} value={list}>{list}</option>
                        )}
                    </select>
                </div>
            )
        }
    }
}

ReactDropDown.propTypes = propTypes;
ReactDropDown.defaultProps = defaultProps;

export default ReactDropDown;